local Lib = MissionMinder;
Lib.callbacks= Lib.callbacks or LibStub("CallbackHandler-1.0"):New(Lib)

local options = Lib.options;
local L = LibStub("AceLocale-3.0"):GetLocale("MissionMinder");
local DEBUG = Lib.debug;

Lib.autoloot = {};
local module = Lib.autoloot;


local function startLooting()
	local clickframe = GarrisonMissionFrame.MissionComplete.BonusRewards.ChestModel.ClickFrame;
	GarrisonMissionCompleteChest_OnMouseDown(clickframe);
end


local ANIM_INDEX_REWARD_PANEL = 7;

-- Keeps track of the resulting animIndex to determine when we finish one animation and begin another
local lastAnimIndex = nil;
local function autoLootAfterFightAnimations(self, elapsed)
	if ( lastAnimIndex ~= self.animIndex ) then
		if( self.animIndex == ANIM_INDEX_REWARD_PANEL ) then -- starting REWARD_PANEL animation
			if( options.AutoLootRewards() and GarrisonMissionFrame.MissionComplete.currentMission.succeeded) then
				startLooting();
			end
		end

		lastAnimIndex = self.animIndex;
	end
end

local function autoLootOnInitialize(missionList, index)
	if ( options.AutoLootRewards() ) then
		local mission = missionList[index];
		if (mission and mission.state >= 0) then
			startLooting();
		end
	end
end

local function initialize()
--function module.initialize()
	DEBUG("   |cffffffffAutoLoot|r initialized")

	-- Start autoloot on mission success
	hooksecurefunc("GarrisonMissionComplete_OnUpdate", autoLootAfterFightAnimations);
	if(GarrisonMissionFrame.MissionComplete:GetScript("OnUpdate")) then
		GarrisonMissionFrame.MissionComplete:HookScript("OnUpdate", autoLootAfterFightAnimations);
	end

	-- Start autoloot on mission complete frame initialize (if it's already received a MissionCompleteResponse, but has not been looted yet)
	hooksecurefunc("GarrisonMissionComplete_Initialize", autoLootOnInitialize);
end

local events = Lib.events
events:RegisterEvent("autoloot", "ADDON_LOADED", initialize);
